;***********************************
; These are for TI-86
;***********************************
#include "ti86.inc"
;
#define Start_Program _asm_exec_ram
#define Link_Off  $0FC
#define Link_Port 7
;*********************************** 

#define Link_On     $0C0        ;same for all z80 TI's

.org Start_Program  ;starts the program

 nop
 jr Start            ;AShell (TI-83) and YAS compatible (TI-86)
.dw     $0000         ;Version of table
.dw     Description   ;Points to the program description
.dw     Icon          ;Points to an 8x8 icon
.dw     $0000         ;For future use (TI-83 AShell only)
 
Description:
 .db "Cartman",0

Icon:               ;attempted pic of cartman
.db %00011000
.db %00111100
.db %01000010
.db %11111111
.db %10100101
.db %10000001
.db %10011001
.db %01111110

Start:
 ld hl,Sound        ;loads the sound data
 di             ;disables interrupts
 ld e,(hl)          ;loads e with hl
 inc hl         ;increases hl
 ld d,(hl)          ;loads d with hl
 inc hl         ;increases hl
 ld b,128           ;stores b as 128
SLoop:
 ld c,19            ;stores c as 19
Loop:
 dec c          ;decreases c
 nop                ;nothing happens here (timing)
 nop                ;nothing happens here (timing)
 nop                ;nothing happens here (timing)
 jr nz,Loop         ;loops until c is 0
 rrc b          ;
 jr nc,Play         ;goes, if no carry, to Play
 inc hl         ;increases hl
 dec de         ;decreases de
 ld a,d         ;loads a with value from d
 or e               ;compares a with e using Boolean 'or'
 jr z,Done          ;if true, goes to Done
Play:
 ld a,(hl)          ;loads a with hl
 and b          ;compares with b using Boolean 'and'
 jr z,Play1         ;if true, go to Play1
 ld a,Link_On      ;load a with the 'Link_Off' value
 out (Link_Port),a  ;turn off the link port
 jr SLoop           ; go to SLoop
Play1:
 ld a,Link_Off      ;load a with the 'Link_On' value
 out (Link_Port),a  ;turn on the link port
 jr SLoop           ; go to SLoop
Done:
 di                 ;disables interrupts
 ret                ;returns from program
 
Sound:
 .dw 2400
 .db $9F,$CF,$7F,$3F,$FF,$FC,$0D,$D2,$C9,$FF,$55,$BE,$9F,$55,$55,$7F
 .db $5D,$B5,$AE,$15,$50,$AB,$D5,$B7,$4A,$EE,$B6,$FA,$A9,$55,$54,$AB
 .db $57,$7F,$B4,$AA,$FA,$BD,$14,$AA,$68,$D5,$5F,$D5,$6A,$C9,$95,$55
 .db $AA,$AA,$AB,$CB,$8D,$55,$5A,$AA,$A7,$A3,$EA,$AE,$8A,$B7,$5A,$15
 .db $5B,$55,$3A,$AB,$55,$AA,$A2,$AB,$5F,$39,$55,$AA,$ED,$2A,$9A,$AA
 .db $55,$4D,$79,$55,$5A,$6D,$AC,$D5,$6B,$6A,$B5,$56,$95,$6D,$96,$DD
 .db $6A,$AA,$5A,$95,$CE,$CB,$B5,$16,$52,$AA,$B5,$56,$9A,$6C,$96,$57
 .db $55,$55,$5A,$2A,$B6,$D2,$E8,$E3,$AE,$5C,$3A,$55,$24,$DA,$34,$DB
 .db $13,$6E,$4D,$BA,$DB,$A5,$2A,$DB,$36,$A9,$6D,$2F,$5B,$7B,$4B,$B6
 .db $6C,$BB,$29,$FF,$0F,$FB,$FC,$BF,$FA,$F9,$AC,$BF,$EC,$FE,$F5,$AB
 .db $F6,$FF,$F6,$92,$25,$B3,$64,$89,$2E,$DB,$D2,$6E,$5B,$6C,$C9,$36
 .db $DB,$32,$6D,$B3,$6C,$93,$56,$DF,$BB,$7B,$26,$DA,$7C,$CB,$39,$2C
 .db $B6,$4D,$A6,$9B,$26,$D2,$6C,$99,$24,$9D,$EE,$C9,$02,$FF,$FC,$00
 .db $07,$FF,$F8,$00,$09,$FF,$E8,$00,$25,$FF,$E8,$00,$25,$FF,$48,$00
 .db $0F,$FE,$80,$00,$9F,$FD,$08,$01,$7F,$FC,$00,$05,$FF,$F2,$00,$05
 .db $FF,$40,$10,$BF,$FA,$50,$09,$7F,$C4,$00,$BF,$EA,$40,$17,$FD,$08
 .db $44,$FD,$A0,$40,$BF,$E8,$00,$5F,$F4,$20,$2F,$FA,$10,$25,$F9,$50
 .db $27,$FB,$50,$2F,$FA,$04,$4F,$F2,$A0,$9F,$E0,$41,$3F,$C9,$82,$FD
 .db $AA,$09,$FE,$0C,$2F,$FA,$40,$9F,$E5,$C0,$FF,$06,$0B,$F4,$B8,$1F
 .db $E0,$A2,$7E,$96,$07,$F8,$20,$BF,$A7,$01,$FC,$50,$6F,$B3,$C2,$FF
 .db $02,$17,$CA,$E1,$7F,$80,$17,$E9,$61,$7F,$80,$17,$E9,$61,$7F,$A0
 .db $17,$D2,$42,$FF,$00,$2F,$D0,$85,$FE,$40,$5F,$C9,$0B,$FD,$01,$7F
 .db $94,$2D,$F2,$06,$FE,$40,$97,$C8,$0A,$F8,$02,$5F,$00,$2B,$E0,$09
 .db $7D,$00,$AF,$A0,$15,$F4,$02,$FE,$80,$5F,$F0,$0B,$7F,$41,$6F,$E0
 .db $17,$FC,$02,$FF,$D0,$2B,$F8,$05,$7F,$00,$37,$E0,$02,$FE,$01,$7F
 .db $C0,$05,$F8,$02,$DF,$80,$2B,$F8,$02,$BF,$00,$5B,$F0,$05,$FE,$00
 .db $57,$E0,$05,$FE,$00,$17,$E0,$05,$FC,$00,$57,$D0,$05,$FC,$10,$5B
 .db $D1,$02,$FE,$08,$2B,$E8,$82,$DE,$08,$25,$F2,$01,$7F,$04,$17,$F9
 .db $40,$BF,$82,$0B,$FC,$A0,$9F,$89,$05,$FE,$50,$5F,$E4,$82,$FF,$28
 .db $2F,$FA,$41,$7F,$94,$1F,$F5,$20,$BF,$4A,$05,$FA,$10,$5F,$A5,$02
 .db $FD,$28,$2F,$FA,$01,$7E,$D5,$0B,$F4,$A0,$5F,$A0,$00,$FF,$40,$07
 .db $FA,$00,$3F,$DC,$05,$FF,$F8,$15,$FB,$E1,$53,$BF,$D0,$25,$5F,$E0
 .db $0A,$FF,$E0,$02,$FF,$E0,$03,$FF,$D0,$0B,$FF,$E0,$01,$7F,$F8,$10
 .db $BF,$FD,$0A,$57,$FA,$85,$2B,$F5,$14,$AD,$78,$12,$B5,$68,$05,$EB
 .db $40,$2B,$D4,$80,$2F,$C0,$02,$D6,$87,$05,$FC,$0F,$0B,$7D,$1E,$07
 .db $F0,$3C,$07,$E0,$7C,$17,$C0,$F8,$1F,$C0,$F8,$3F,$83,$F0,$3F,$07
 .db $C0,$7C,$0F,$80,$78,$3F,$80,$F8,$7F,$03,$F0,$7E,$05,$E0,$FC,$0B
 .db $E1,$F8,$0B,$C1,$F8,$17,$83,$F0,$0F,$87,$E0,$2F,$07,$E0,$1F,$0F
 .db $C0,$5E,$0F,$80,$5E,$0F,$80,$BE,$1F,$00,$B6,$5F,$00,$BC,$1F,$00
 .db $3C,$9F,$02,$3C,$9F,$00,$3C,$1F,$02,$3E,$1F,$00,$3C,$1F,$00,$3E
 .db $1F,$02,$36,$1F,$00,$36,$5F,$05,$1E,$4F,$80,$1E,$4F,$00,$1F,$0F
 .db $80,$1F,$0F,$80,$1F,$2F,$80,$0F,$2F,$80,$AF,$87,$C0,$0F,$97,$C0
 .db $07,$83,$C0,$07,$C3,$E0,$23,$E9,$E0,$0B,$E1,$F0,$03,$E5,$F0,$01
 .db $E4,$F0,$01,$E5,$F0,$05,$E0,$F0,$01,$E0,$F0,$05,$F0,$F8,$05,$E0
 .db $F0,$05,$F2,$F8,$01,$E0,$F0,$05,$E2,$F8,$01,$E1,$F0,$01,$E1,$F0
 .db $29,$E4,$F0,$0B,$E5,$F0,$0B,$E5,$F0,$2B,$E5,$F0,$0B,$C5,$E0,$03
 .db $C1,$E0,$0B,$E5,$F0,$03,$C1,$E0,$03,$C1,$E0,$43,$C1,$E0,$03,$C3
 .db $E0,$0B,$C1,$E0,$03,$C1,$E0,$0B,$E5,$F0,$0B,$E5,$F0,$01,$E5,$F0
 .db $01,$E0,$F0,$05,$F0,$F8,$00,$F2,$78,$22,$F8,$7C,$00,$79,$7C,$01
 .db $7C,$3E,$01,$7C,$3E,$00,$3C,$1E,$01,$2C,$1E,$01,$2C,$9E,$01,$7C
 .db $3E,$01,$78,$3E,$02,$78,$3C,$02,$F0,$7C,$05,$F0,$F8,$0B,$E1,$F0
 .db $0F,$C3,$E0,$3F,$07,$C0,$7E,$0F,$80,$F8,$3E,$03,$F0,$FC,$07,$C1
 .db $F8,$0F,$87,$E0,$3E,$0F,$80,$F8,$1F,$01,$F0,$7C,$07,$E0,$F8,$1F
 .db $83,$E0,$FC,$01,$FC,$02,$FC,$07,$F8,$07,$F4,$0B,$F8,$0F,$F0,$1F
 .db $F0,$2F,$E0,$3F,$E0,$1F,$C0,$3F,$C0,$3F,$C0,$7F,$C0,$5F,$C0,$1F
 .db $E0,$0F,$F0,$07,$F8,$01,$FF,$00,$3F,$E0,$07,$FC,$00,$FF,$A9,$AD
 .db $7F,$F9,$7B,$DF,$FB,$5B,$FF,$4F,$FB,$53,$7B,$03,$BF,$F5,$7D,$7D
 .db $FF,$F5,$5F,$F6,$AD,$FF,$B7,$FF,$FE,$FF,$FF,$BF,$BF,$FE,$FC,$F7
 .db $57,$FF,$FD,$D7,$FF,$D7,$FF,$F7,$FF,$DA,$FF,$DF,$FD,$D7,$FE,$BA
 .db $BC,$FF,$FF,$47,$BF,$FF,$A4,$F6,$DD,$EE,$FE,$FF,$FB,$FB,$FF,$FF
 .db $F6,$FF,$7F,$8F,$D3,$FF,$6F,$BF,$FF,$FF,$FF,$FF,$C7,$FD,$BF,$BF
 .db $EF,$7F,$FF,$FF,$FC,$BF,$FF,$DF,$EF,$DF,$5F,$7F,$FF,$FF,$FE,$9F
 .db $FF,$7F,$EF,$FF,$FF,$F2,$FF,$F4,$7F,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$FB,$EF,$EF,$FF,$F7,$FF,$FF,$F7,$FE,$7F,$EF,$B4,$F3,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FA,$FD,$DC,$FF,$ED,$FB,$FF,$FF,$FD,$FF,$FF,$FF
 .db $7C,$FA,$BF,$7B,$2F,$FF,$FF,$EE,$FF,$FF,$BB,$FE,$F4,$5A,$67,$FC
 .db $FF,$F4,$FF,$FF,$FF,$FF,$77,$FF,$FF,$FF,$62,$7D,$FF,$FF,$F7,$FB
 .db $FF,$FF,$FE,$FE,$ED,$FF,$FF,$FF,$7F,$BF,$FF,$DF,$FF,$5F,$F7,$FF
 .db $FF,$FF,$EF,$FF,$FF,$FF,$CF,$FF,$FF,$FC,$F9,$8F,$9F,$EF,$FF,$FF
 .db $F7,$FF,$FF,$FF,$56,$FD,$F4,$FF,$7F,$FF,$FF,$FE,$FF,$FF,$FF,$FE
 .db $53,$FF,$EF,$8F,$D3,$FF,$F3,$DF,$FF,$FF,$F8,$DF,$FF,$62,$71,$FF
 .db $FF,$59,$EE,$FF,$FF,$FF,$FF,$97,$7F,$FE,$F8,$0B,$DF,$FF,$7F,$FF
 .db $FC,$EF,$FF,$FF,$BE,$FF,$EF,$FD,$FE,$C7,$FF,$FF,$FF,$FF,$F1,$FB
 .db $F9,$95,$3E,$4C,$DF,$FF,$AE,$F7,$FF,$D3,$5F,$EE,$E1,$FF,$FF,$07
 .db $FF,$F7,$FF,$EF,$FF,$BF,$3F,$FF,$BE,$97,$7F,$BF,$BF,$D7,$FF,$FF
 .db $FB,$FF,$FC,$5E,$BF,$DC,$7F,$FC,$7E,$AE,$FF,$5F,$FB,$FF,$FE,$FA
 .db $FD,$F3,$48,$7F,$BD,$F5,$B7,$F6,$B6,$97,$FF,$ED,$6F,$7B,$DA,$D5
 .db $FD,$AB,$FB,$D6,$95,$AD,$EF,$EB,$5F,$CB,$49,$DD,$FD,$FF,$FF,$5E
 .db $FE,$91,$EB,$A9,$FF,$FF,$F6,$D7,$FB,$FC,$FC,$7F,$FF,$FD,$DF,$79
 .db $FF,$FF,$EF,$FF,$FF,$BB,$DF,$FF,$FF,$DF,$11,$FF,$FF,$B4,$77,$FF
 .db $FD,$DF,$FB,$77,$DF,$FF,$9F,$FF,$B5,$FD,$7F,$BD,$EF,$FF,$FF,$7D
 .db $7F,$71,$FF,$F5,$FF,$FF,$F7,$15,$C0,$7F,$F7,$BF,$FD,$FF,$57,$F0
 .db $7F,$FE,$13,$FD,$FC,$07,$C3,$F4,$B4,$FB,$ED,$26,$BD,$15,$F6,$90
 .db $49,$F4,$17,$5F,$C1,$7D,$2F,$9B,$05,$F4,$BF,$C0,$4B,$2F,$BE,$00
 .db $5B,$6F,$E0,$12,$FB,$7F,$00,$A7,$D7,$F8,$05,$BE,$BE,$80,$05,$F6
 .db $FA,$00,$37,$D3,$F8,$00,$5F,$4F,$E0,$01,$7F,$BF,$80,$02,$FF,$7F
 .db $80,$02,$FF,$2F,$80,$02,$FD,$3F,$80,$41,$7F,$97,$C0,$00,$5F,$65
 .db $F0,$00,$17,$D1,$7C,$04,$52,$FA,$2F,$00,$10,$7F,$A7,$F0,$00,$05
 .db $FA,$4D,$00,$90,$2F,$B2,$D8,$04,$15,$FE,$CB,$60,$00,$56,$FA,$2C
 .db $80,$8A,$2B,$AC,$92,$41,$05,$57,$E9,$A6,$82,$0A,$B5,$51,$64,$12
 .db $45,$57,$49,$A6,$81,$05,$5A,$AA,$B2,$0A,$A2,$AD,$52,$6D,$82,$C8
 .db $AB,$55,$95,$60,$40,$3E,$DF,$D5,$10,$10,$0F,$BF,$D5,$51,$00,$01
 .db $77,$FE,$A8,$80,$00,$3E,$FF,$F5,$00,$00,$03,$DF,$FE,$E0,$00,$00
 .db $79,$FF,$DC,$00,$00,$0F,$BF,$FD,$45,$00,$00,$F3,$FF,$A0,$00,$00
 .db $1E,$7F,$F5,$00,$00,$03,$EF,$FF,$50,$00,$00,$1C,$FF,$D5,$44,$00
 .db $07,$9F,$DA,$EA,$00,$00,$56,$FE,$BD,$20,$51,$55,$EA,$CA,$A2,$08
 .db $8A,$D5,$6F,$D1,$04,$55,$6A,$B7,$68,$80,$00,$2F,$D7,$E8,$90,$01
 .db $6B,$B7,$E8,$04,$00,$5F,$A5,$CA,$20,$02,$BF,$6B,$D2,$88,$02,$FF
 .db $AF,$C2,$00,$05,$FE,$5F,$A0,$00,$0F,$FE,$FC,$00,$00,$BF,$FB,$7E
 .db $00,$01,$FF,$DE,$A0,$00,$07,$FF,$FF,$80,$00,$7F,$FF,$80,$00,$01
 .db $FF,$FE,$90,$00,$03,$FF,$D0,$00,$00,$1F,$FF,$40,$00,$00,$BF,$F8
 .db $00,$00,$02,$FF,$E5,$28,$00,$5B,$FE,$A5,$20,$01,$7B,$D0,$AD,$00
 .db $0A,$DE,$A1,$6A,$00,$56,$FD,$4B,$50,$04,$BF,$CA,$FC,$00,$2F,$FC
 .db $B7,$E0,$02,$DF,$29,$FA,$80,$25,$F2,$5F,$A0,$01,$5F,$A5,$DA,$00
 .db $17,$FB,$5D,$80,$11,$7F,$97,$F8,$00,$1A,$E9,$3E,$80,$08,$BF,$CB
 .db $EC,$02,$0D,$F4,$DF,$40,$00,$5F,$A6,$FA,$08,$22,$FD,$3F,$D0,$00
 .db $1A,$E9,$BA,$48,$20,$5F,$2D,$D2,$00,$2A,$5D,$B6,$4A,$00,$AB,$76
 .db $D9,$28,$02,$AD,$DB,$64,$80,$02,$D5,$6D,$D2,$00,$0B,$54,$97,$44
 .db $00,$25,$DB,$74,$91,$00,$17,$ED,$D2,$E4,$0A,$D5,$27,$CB,$00,$0A
 .db $F5,$BF,$44,$11,$57,$AD,$FA,$20,$8A,$BF,$6F,$D0,$00,$05,$F2,$7D
 .db $00,$00,$5F,$27,$D0,$00,$0B,$F4,$FD,$00,$01,$7E,$DF,$A0,$00,$2F
 .db $D3,$EC,$02,$0B,$F6,$FD,$00,$03,$7D,$B7,$40,$00,$BF,$5F,$F0,$00
 .db $2F,$F7,$F8,$00,$17,$DB,$FD,$00,$17,$FB,$FD,$00,$17,$FB,$FC,$00
 .db $17,$FB,$FE,$00,$15,$FF,$FC,$00,$0B,$FF,$FC,$00,$17,$DF,$F0,$01
 .db $5F,$FF,$E0,$05,$7F,$FF,$80,$05,$FF,$FE,$00,$1F,$FB,$F8,$00,$5F
 .db $FF,$C0,$03,$FF,$FF,$00,$0B,$FF,$F8,$00,$5F,$FF,$C0,$00,$FF,$FC
 .db $00,$2F,$FF,$E0,$00,$7F,$FE,$00,$07,$FF,$F0,$00,$3F,$FF,$00,$02
 .db $FF,$F8,$00,$1F,$FF,$80,$00,$FF,$FC,$00,$07,$FF,$C0,$00,$7F,$FD
 .db $00,$03,$FF,$E0,$00,$3F,$FF,$00,$00,$FF,$F0,$00,$0F,$FF,$40,$00
 .db $7F,$FC,$00,$07,$FF,$E0,$00,$1F,$FF,$00,$00,$FF,$F8,$00,$07,$FF
 .db $E0,$00,$3F,$FF,$00,$02,$FF,$FC,$00,$0B,$FF,$F0,$00,$3F,$FF,$80
 .db $00,$7F,$FE,$00,$03,$FF,$F8,$00,$0F,$FF,$F0,$00,$1F,$FF,$E0,$00
 .db $3F,$FF,$C0,$00,$3F,$FF,$80,$00,$7F,$FF,$00,$00,$7F,$FE,$80,$01
 .db $7F,$FE,$80,$01,$FF,$FE,$00,$01,$7F,$FF,$00,$01,$7F,$FF,$00,$00
 .db $3F,$FF,$80,$00,$5F,$FF,$E0,$00,$2F,$FF,$F0,$00,$17,$FF,$FC,$00
 .db $05,$FF,$FF,$00,$00,$BF,$FF,$E0,$00,$17,$FF,$FC,$00,$03,$FF,$FF
 .db $80,$00,$17,$FF,$FC,$00,$05,$FF,$FF,$E0,$00,$07,$FF,$FF,$80,$00
 .db $07,$FE,$FE,$00,$00,$07,$F6,$FE,$00,$00,$29,$7F,$BF,$00,$00,$07
 .db $BF,$F6,$D0,$00,$00,$5D,$FE,$97,$C0,$00,$07,$F2,$FA,$4D,$00,$10
 .db $17,$F6,$FA,$0B,$00,$B0,$0F,$E2,$FA,$4D,$00,$B0,$0F,$F5,$AE,$92
 .db $80,$2A,$82,$FA,$B5,$D2,$58,$05,$A0,$FE,$AA,$D1,$4D,$04,$F4,$17
 .db $FD,$57,$8A,$78,$2F,$A0,$BE,$AA,$AD,$14,$D0,$4F,$01,$FE,$BE,$B5
 .db $52,$D9,$4F,$01,$FF,$FE,$8B,$45,$3C,$92,$C0,$7F,$FF,$81,$5D,$2F
 .db $D4,$50,$5F,$F5,$54,$6B,$2D,$F4,$12,$03,$FF,$F4,$05,$B2,$DF,$80
 .db $00,$BF,$FE,$80,$2F,$A5,$F4,$00,$01,$FF,$E5,$01,$7D,$2F,$E0,$00
 .db $0F,$FD,$20,$05,$FE,$BF,$80,$00,$3F,$FE,$00,$0B,$FD,$7D,$00,$13
 .db $FF,$E0,$00,$1B,$FB,$7E,$00,$83,$FF,$E0,$00,$17,$FA,$FA,$00,$2F
 .db $FF,$A0,$00,$2F,$F6,$F0,$00,$1F,$FF,$C0,$00,$2F,$FD,$F0,$00,$7F
 .db $FF,$C0,$00,$2F,$F4,$B0,$00,$7F,$FF,$C0,$00,$5B,$FF,$48,$00,$3F
 .db $FF,$C0,$00,$3F,$FF,$C8,$00,$0F,$FF,$F8,$00,$2A,$FF,$D0,$00,$01
 .db $FF,$FF,$00,$01,$DF,$FF,$40,$00,$1F,$FF,$E0,$00,$BF,$FF,$C1,$00
 .db $2D,$FF,$F0,$00,$55,$FF,$E0,$00,$07,$FF,$FE,$00,$0F,$FF,$F8,$00
 .db $01,$FF,$FE,$00,$05,$FF,$FF,$00,$00,$FF,$FF,$01,$40,$7D,$7F,$80
 .db $A0,$0F,$FF,$F0,$00,$3F,$7F,$E4,$A0,$03,$FF,$F8,$00,$12,$FF,$FB
 .db $00,$01,$FF,$FC,$00,$01,$FF,$FF,$80,$07,$FF,$F0,$00,$0F,$FF,$FC
 .db $00,$1F,$FF,$C0,$00,$3F,$FF,$F8,$00,$FD,$FE,$00,$00,$BF,$DF,$E0
 .db $07,$C7,$F0,$00,$02,$FF,$DF,$C0,$1F,$5F,$E0,$00,$0B,$FF,$FF,$00
 .db $B8,$BF,$80,$00,$5F,$FF,$F8,$03,$85,$FC,$00,$00,$FF,$5F,$C0,$0F
 .db $1F,$F0,$00,$07,$FE,$FF,$00,$E8,$FF,$C0,$00,$3F,$F7,$F0,$03,$EB
 .db $FC,$00,$01,$FF,$FF,$80,$1F,$FF,$E0,$00,$0F,$FF,$F8,$01,$8F,$FF
 
.end
